<?php

function smarty_function_link($params, &$smarty){

    $PATH = (isset($params['path'])) ? $params['path'] : $smarty -> get_template_vars('SZABLON_URL');

/**************************************************************************************************/

    $response = '';
    
    if ( isset($params['css']) ) {
        if ( empty($params['pack']) ) {
            $css  = __link_explode($params['css'], 'css');
            $path = $PATH.'/style/';

            foreach( $css as $plik ) {
                $response .= '<link rel="stylesheet" href="'.__link_plik_url( $plik, $path ) . '.css" type="text/css">'. "\n";
            }
        } else {
            $response .= '<link rel="stylesheet" href="' . __link_strip_ext($params['css'], 'css') . '.css" type="text/css">'. "\n";
        }
    }

    if ( isset($params['js']) ){
        if ( empty($params['pack']) ) {
            $js = __link_explode($params['js'], 'js');
            $path = $PATH . '/script/';

            foreach( $js as $plik ) {
                $response .=  '<script type="text/javascript" src="'. __link_plik_url( $plik, $path ) . '.js"></script>' . "\n";
            }
        } else {
            $response .= '<script type="text/javascript" src="'.__link_strip_ext($params['js'], 'js').'.js"></script>'. "\n";
        }
    }

/**************************************************************************************************/

    echo $response;
}

function __link_strip_ext( $plik, $type = 'js' ) {

    if ( $len = strlen($type) ) {
        $len++; //zwiekszam o jeden bo jeszcze kropka '.'
        while ( strcasecmp( substr( $plik, -1 * $len ), '.' . $type ) == 0 ) {
            $plik = substr( $plik, 0, -1 * $len );
        }
    }
    
    return $plik;
}


function __link_explode( $str, $type = 'js' ){
    $pliki = explode(',', $str );

    for( $len = strlen($type) + 1, $i = 0, $lp = count($pliki); $i < $lp; $i++ ){
        $pliki[$i] = __link_strip_ext(trim($pliki[$i]), $type);
    }
    
    return $pliki;
}

function __link_plik_url( $plik, &$path ) {

    if ( substr($plik, 0, 1) == '/' ) {
        $path = dirname($plik) . '/' ;
        $plik = basename($plik);
    }
    
    return $path . $plik;
}

