<?php
/**
 * Smarty plugin
 * @package Smarty
 * @subpackage plugins
 */


/********************************************************************************
 * Copyright (c) 2009 Opineo.pl                                                 *
 *                                                                              *
 * Wykorzystywanie i rozpowszechnianie niniejszego skryptu do celow             *
 * innych niz okreslono na stronie http://www.opineo.pl/?administraca=8         *
 * jest ZABRONIONE.                                                             *
 *                                                                              *
 * Skrypt przeznaczony dla wybranych partnerow Opineo.                          *
 * Wykorzystywanie przez inny podmiot ZABRONIONE.                               *
 ********************************************************************************/


/**
   * Wywolanie funkcji powinno nastapic w w takim miejscu w kodzie,
   * w ktorym transakcja zostala zakonczona. Funkcja polaczy sie
   * z serwerem Opineo i automatycznie dokona zgloszenia adresu email
   * Klienta.
   *
   * Po 5 dniach zostanie do klienta wyslany email z zaproszeniem do
   * wystawienia opinii i jednorazowym linkiem prowadzacym do formularza
   * oceny sklepu.
   *
   * Do celow testowania mozna posluzyc sie stala OPINEO_DEBUG. Jej ustawienie
   * powoduje zwracanie zawsze tego samego kodu bledu -- ustawionego w OPINEO_DEBUG.
   *
   * @param string $adres email klienta, do ktorego nalezy wyslac zaproszenie
   * @param string $login identyfikator uzytkownika administrujacego sklepem na Opineo
   * @param string $haslo uzytkownika Opineo administrujacego danymi sklepu
   * @param int $czas liczba dni po ilu ma zostac wyslane zaproszenie. Dopuszczalne wartosci t: 1, 5 (domyslnie), 10.
   *
   * @return array kod bledu, jesli wystapil (0 -- powodzenie) oraz stosowny komunikat;
   *   false, gdy nie mozna nawiazac polaczenia z serwerem.
*/


function smarty_function_opineo_zaproszenie($params, &$smarty){
    
    $email = $login = $haslo = ''; $czas = 5;
    
    if( isset($params['adres']) ){
        $params['email'] = $params['adres'];
    }
    
    if( isset($params['pass']) ){
        $params['haslo'] = $params['pass'];
    }
    
    extract($params, EXTR_OVERWRITE );
    
    if( empty($email) ){
        return;
    }
    
    if( empty($login) || empty($haslo) ){
        return;
    }
    
    if( $czas != 5 && $czas != 1 && $czas != 10){
        $czas = 5;
    }

    $query = http_build_query(Array(
        'type'   =>  'customer',
        'email'  =>  $email,
        'login'  =>  $login,
        'pass'   =>  $haslo,
        'queue'  =>  $czas,
    ));
    
    $url = 'http://www.opineo.pl/gate.php?' . $query;
    
    $json = @file_get_contents($url);
    if ( $json === false ){
        add2log(0, 'Dla sklepu: '.$login.' nie udao si wysa zgoszenia adresu e-mail: '.$email.' do serwisu Opineo.pl.', __FILE__, __LINE__);
        return false;
    }

    if( function_exists('json_decode') ){
        $res = json_decode($json, true);
    }

    add2log(0, 'Pomylnie dokonano zgoszenia adresu e-mail: '.$email.' do serwisu Opineo.pl dla sklepu: '.$login.'. Zwrcona odpowied: ' . $json, __FILE__, __LINE__, $res );

    return null;
}

?>
