
(function($){
    var _elements;
    var progi_cen = {};
    //aktualne progi cenowe
    var items = null;
    var $element;
    var $progCenowyDialog;
    var progCenowyIndex = -1;

    /**
     * Generowanie html'u i przypicie go do selektora
     */
    function progiCenInit(options){
        $element = $(options.target);

        if ( $element.data ( 'ecProgiCenOptions') ){
            return false;
        }

        $element.data ( 'ecProgiCenOptions', options );

        /**
         * Tabela progw
         */
        var $table = $('<table class="grid" width="80%" border=0 cellspacing=0 cellpading=5>' + "\n" +
                '<tr>' + "\n" +
                    '<th width="15px">Lp.</th>' + "\n" +
                    '<th>Prg od</th>' + "\n" +
                    '<th>Cena</th>' + "\n" +
                    '<th>Akcje</th>' + "\n" +
                 '</tr>' + "\n" +
            '</table>');

        $element.append($table);

        if ( options.items ) {
            printTable( $element.find('table'), options.items );
        }
    }

    function floatval( val ){
        if ( typeof(val) == 'string' ) {
            val = val.replace(',', '.');
        }

        val = parseFloat(val);
        if ( isNaN(val) ) {
            val = 0;
        }

        return val;
    }

    function printTable( $table, items ) {
        var rows = $table.find('tr');

        for ( var i = 1; i < rows.length; i++ ) {
            $(rows[i]).remove();
        }

        if ( items ) {
            for ( var i = 0; i < items.length; i++ ){
                $table.append( printTableRow(items[i], i+1) );
            }
        }

        progiCenoweZapisz();
    }

    function printTableRow ( item, lp ) {

        var $row = $('<tr>');
        if ( lp % 2 == 1 ) {
            //$row.addClass('odd');
        }

        var $a_del   = $('<a>').html('&amp;').attr('href', '#').button({
            'text': false,
            'icons' : {
                'primary' : 'ui-icon-trash'
            }
        }).click(progCenowyUsun);

        var $a_edit   = $('<a>').html('&amp;').attr('href', '#').button({
            'text': false,
            'icons' : {
                'primary' : 'ui-icon-pencil'
            }
        }).click(progCenowyEdytuj);

        var $td = $('<td>');

        $row.append($td.clone().html( lp + '. ' ).attr('align', 'right'));
        $row.append($td.clone().html( currency_format(item.prog_od) ).attr('align', 'right') );
        $row.append($td.clone().html( item.cena_nazwa ).attr('align', 'left') );
        $row.append($td.attr('align', 'center').append( $a_edit  ).append($a_del) );

        return $row;
    }


    function progCenowyZapisz( e ){
        if( e && e.preventDefault() ) e.preventDefault();

        var options = $element.data('ecProgiCenOptions');
        var items = options.items;

        var errors = {};
        var i = ( progCenowyIndex >= 0 ) ? progCenowyIndex : items.length;
        var item = {};

        item.prog_od = floatval($progCenowyDialog.find('input[name=prog_od]').val());
        var $cena_id = $progCenowyDialog.find('select[name=cena_id]')
        item.cena_id = floatval($cena_id.val());
        item.cena_nazwa = $cena_id[0].options[$cena_id[0].selectedIndex].text;

        if ( i > 0 ) {
            if ( item.prog_od <= items[i-1].prog_od ) {
                errors.prog_od = "Warto progu musi by wiksza od " + items[i-1].prog_od;
            }

//            if ( item.rabat <= items[i-1].rabat ) {
//                errors.rabat = "Warto rabatu musi by wiksza od " + items[i-1].rabat;
//            }
        } else {
            if ( item.prog_od <= 0 ) {
                errors.prog_od = "Warto progu musi by wiksza od zera";
            }

//            if ( item.rabat <= 0 ) {
//                errors.rabat = "Warto rabatu musi by wiksza od zera";
//            }
        }

        if ( i + 1 < items.length ) {
            if ( item.prog_od >= items[i+1].prog_od ) {
                errors.prog_od = "Warto progu musi by mniejsza ni " + items[i+1].prog_od;
            }

//            if ( item.rabat >= items[i+1].rabat ) {
//                errors.rabat = "Warto rabatu musi by mniejsza ni " + items[i+1].rabat;
//            }
        }

        if ( !item.cena_id ) {
            errors.cena_id = "Wybierz cen, ktra bdzie obowizywaa dla danego progu ";
        } else {
            for ( var j = 0; j < items.length; j++) {
                if ( item.cena_id == items[j].cena_id && (j != i) ) {
                    errors.cena_id = "Wybrana cena jest ju wykorzystana dla innego progu ";
                }
            }
        }


        if ( errors.prog_od || errors.cena_id ) {
            var msg = '';
            if ( typeof($.validator) != 'undefined' ) {
                $progCenowyDialog.find('form').validate().showErrors( errors );
            } else {
                msg += "\n";
                for( var e in errors ){
                    msg += errors[e] + "\n";
                }
            }

            alert('Popraw bdy!' + msg );
        } else {
            if ( progCenowyIndex === -1) {
                $element.find('table').append(printTableRow ( item, options.items.length+1 ) ) ;
                options.items.push(item);
            } else {
                $element.find('tr:eq('+(progCenowyIndex+1)+')').replaceWith( printTableRow ( item,  progCenowyIndex+1 ) );
                options.items[progCenowyIndex] = item;
            }

            $element.data('ecProgiCenOptions', options);
            $progCenowyDialog.dialog('close');

            progiCenoweZapisz();
        }

        return false;
    }

    function progiCenoweZapisz ( ) {
        var options;
        if ( arguments[0] ){
            options = arguments[0];
        }else if ( $element ) {
            options = $element.data('ecProgiCenOptions');
        }

        if( !options ){
            return;
        }

        $(options.target).find('input').remove();

        for ( var i = 0; i < options.items.length ; i++  ){
            for( var a in options.items[i] ) {
                $(options.target).append('<input type="hidden" name="'+options.input+'[' + ( i ) + ']['+a+']" value="' + options.items[i][a] + '" />');
            }
        }
    }

    function progCenowyDialogOpen ( item ) {

        if( !$progCenowyDialog ){
            $progCenowyDialog  = $('#progCenowyDialog').dialog({
                'open' : false,
                'width' : 600,
                'height' : 240,
                'buttons' : {
                    'Anuluj' : function(){
                        $progCenowyDialog.dialog('close');
                    },

                    'OK' : progCenowyZapisz
                }
            });

            $progCenowyDialog.find('input[type=submit]').hide();
            $progCenowyDialog.find('form').submit(progCenowyZapisz);
        }

        $progCenowyDialog.find('input[type=text],select').val('');
        if ( item ) {
            for ( var a in item ) {
                $progCenowyDialog.find('input[name=' + a + ']').val(item[a]);
                $progCenowyDialog.find('select[name=' + a + ']').val(item[a]);
            }
        }

        $progCenowyDialog.dialog('open');
    }

    function progCenowyDodaj ( ) {
        progCenowyIndex = -1;

        progCenowyDialogOpen();
    }

    function progCenowyEdytuj ( e ) {
        e.preventDefault();
        $element = $(this).parents('table:first').parent();

        var $tr = $(this).parents('tr');
        progCenowyIndex = $tr.index() - 1;

        var options = $element.data('ecProgiCenOptions');
        progCenowyDialogOpen( options.items[progCenowyIndex] );

        return false;
    }

    function progCenowyUsun ( e ) {
        e.preventDefault();

        if ( confirm('Jeste pewien, e chcesz usun prg cenowy?') ) {
            var $tr = $(this).parents('tr:first');
            var $table = $tr.parents('table:first');

            $element = $table.parent();

            var i = $tr.index() - 1;
            var options = $table.parent().data('ecProgiCenOptions');
            options.items.splice( i, 1);

            $tr.remove();

            $table.find('tr:gt(0)').each(function( i, el ){
                $(el).attr('class', ((i+1) % 2)  ? 'odd' : 'even');
                $(el).find('td.num').html( (i + 1) + '.');
            });

            progiCenoweZapisz();
        }

        return false;
    }

    if ( $.fn.ecProgiCen ) {
        return;
    }


    $.fn.ecProgiCen = function( options ){
        /**
         * Opcje pluginu (Komunikaty i cieki url do akcji)
         */
        options = $.extend({
            items : [],
            name  : $(this).attr('id'),
            target : (!$(this).attr('href') || $(this).attr('href') == '#') ? $(this).attr('rel') : $(this).attr('href'),
            title : $(this).attr('title')
        }, options || {} );

        if ( options.target && options.target.substr(0, 1) != '#' ){
            options.target = '#' + options.target;
        }

        if ( typeof(options.items) !== 'object' || options.items === null || typeof(options.items.length) === 'undefined' ) {
            options.items = [];
        }

        progiCenInit(options);

        this.button({
            'text' : '',
            'icons' : {
                'primary' : 'ui-icon-plus'
            }
        }).click (function ( e ){
            e.preventDefault();

            var href = $(this).attr('href');
            var href_match = href ? href.match(/#.*$/) : false;
            if ( href_match ) {
                href = href_match[0]
            }

            if ( href ) {
                $element = $( href );

                if ( $element.length === 1 ) {
                    currentIndex = -1;
                    progCenowyDodaj();
                } else {
                    console.log('Nie znaleziono obiektu: ' + href );
                }
            }

            return false;
        });
    }

})(jQuery);
