<?php
    if( get_db_firm_ver($this->dbh) > 110 ){
        
        //w tym wypadku bez transakcji
        $this->db_start_trans();

        $res = $this->db_query("SELECT rc.RDB\$CONSTRAINT_NAME,
                         s.RDB\$FIELD_NAME AS field_name,
                         CASE WHEN rc.RDB\$CONSTRAINT_TYPE = 'PRIMARY KEY' THEN 1 ELSE 0 END AS \"primary\",
                         CASE WHEN rc.RDB\$CONSTRAINT_TYPE = 'FOREIGN KEY' THEN 1 ELSE 0 END AS \"foreign\",
                         CASE WHEN rc.RDB\$CONSTRAINT_TYPE = 'UNIQUE'      THEN 1 ELSE 0 END AS \"unique\",
                         CASE WHEN rc.RDB\$CONSTRAINT_TYPE = 'CHECK'       THEN 1 ELSE 0 END AS \"check\",
                         i.RDB\$DESCRIPTION AS description,
                         CASE WHEN rc.RDB\$DEFERRABLE = 'NO' THEN 0 ELSE 1 END AS deferrable,
                         CASE WHEN rc.RDB\$INITIALLY_DEFERRED = 'NO' THEN 0 ELSE 1 END AS initiallydeferred,
                         refc.RDB\$UPDATE_RULE AS onupdate,
                         refc.RDB\$DELETE_RULE AS ondelete,
                         refc.RDB\$MATCH_OPTION AS \"match\",
                         i2.RDB\$RELATION_NAME AS references_table,
                         s2.RDB\$FIELD_NAME AS references_field,
                         (s.RDB\$FIELD_POSITION + 1) AS field_position
                    FROM RDB\$INDEX_SEGMENTS s
               LEFT JOIN RDB\$INDICES i ON i.RDB\$INDEX_NAME = s.RDB\$INDEX_NAME
               LEFT JOIN RDB\$RELATION_CONSTRAINTS rc ON rc.RDB\$INDEX_NAME = s.RDB\$INDEX_NAME
               LEFT JOIN RDB\$REF_CONSTRAINTS refc ON rc.RDB\$CONSTRAINT_NAME = refc.RDB\$CONSTRAINT_NAME
               LEFT JOIN RDB\$RELATION_CONSTRAINTS rc2 ON rc2.RDB\$CONSTRAINT_NAME = refc.RDB\$CONST_NAME_UQ
               LEFT JOIN RDB\$INDICES i2 ON i2.RDB\$INDEX_NAME = rc2.RDB\$INDEX_NAME
               LEFT JOIN RDB\$INDEX_SEGMENTS s2 ON i2.RDB\$INDEX_NAME = s2.RDB\$INDEX_NAME
                     AND s.RDB\$FIELD_POSITION = s2.RDB\$FIELD_POSITION
                   WHERE UPPER(i.RDB\$RELATION_NAME)= 'WWW_USERS_CONFIG'
                     AND rc.RDB\$CONSTRAINT_TYPE IS NOT NULL
                ORDER BY s.RDB\$FIELD_POSITION");
                
        if( $res ){
            $constraint = $WWW_USERS_CONFIG_CONSTRAINTS = array();

            while( $row = ibase_fetch_assoc($res) ){
                foreach($row as $k=>$v){ $row[$k] = trim($v);}
                
                if( strtoupper(trim($row['FIELD_NAME'])) == 'ZK_DOC_ID' ){
                    $constraint = $row;
                }
                
                $WWW_USERS_CONFIG_CONSTRAINTS[] = $row;
            }
            ibase_free_result($res);
            
            if( !empty($constraint) ){
                if( !$this->db_query( 'ALTER TABLE WWW_USERS_CONFIG DROP CONSTRAINT ' . $constraint['RDB$CONSTRAINT_NAME'] ) ){
                    return false;
                }
                //if( !$this->db_commit() ) return false;  $this->db_start_trans();
            }
        }

/**************************************************************************************************/

        if( ! $res = $this->db_query("SELECT * FROM R3_KODY_DOK_SP ") ){
            return false;
        }
        
        $docs = array();
        while( $row = ibase_fetch_assoc($res) ){
            $docs[$row['ID']] = $row;
        }
        ibase_free_result($res);
        
        $this->ZAMOWIENIE_ID = ( $this->ZAMOWIENIE_ID > 0 && isset($docs[$this->ZAMOWIENIE_ID]) ) ? $docs[$this->ZAMOWIENIE_ID]['ID_KODU'] : $this->ZAMOWIENIE_ID;
        $this->ZD_DOC_ID = ( $this->ZD_DOC_ID > 0 && isset($docs[$this->ZD_DOC_ID]) ) ? $docs[$this->ZD_DOC_ID]['ID_KODU'] : $this->ZD_DOC_ID;

/**************************************************************************************************/

        if( !($res = $this->db_query('SELECT * FROM WWW_USERS_CONFIG WHERE ZK_DOC_ID IS NOT NULL ')) ){
            return false;
        }
        $update = false;
        while( $row = ibase_fetch_assoc($res) ){
            $update = true;
            if( !$this->db_query('UPDATE WWW_USERS_CONFIG SET ZK_DOC_ID = '.( isset($docs[$row['ZK_DOC_ID']]) ? $docs[$row['ZK_DOC_ID']]['ID_KODU'] : 'NULL' ).' WHERE USER_ID = ' . $row['USER_ID'] ) ){
                return false;
            }
        }
        ibase_free_result($res);

        if( $update ){
            if( !$this->db_commit() ) return false;
            
            $this->db_reconnect();

            $this->db_start_trans();
        }
        
/**************************************************************************************************/

        if( !$this->db_query( 'ALTER TABLE WWW_USERS_CONFIG ADD CONSTRAINT WWW_USERS_CONFIG_ZK_DOC_ID_FK FOREIGN KEY (ZK_DOC_ID) REFERENCES R3_KODY_DOK(ID) ON DELETE SET NULL ON UPDATE CASCADE' ) ){
            return false;
        }
        
        if( !$this->db_commit() ) return false;
    }
    
    return true;
?>
